## ball 1.4.0

=== CMakeLists.txt ===
# CMake configuration for BALL (http://www.ball-project.org)
#
# This file is - on purpose - heavily based on the CMake configuration
# of OpenMS (http://www.openms.de) to optimize synergy effects

PROJECT("BALL")

# TODO LIST:
#   BALL specific:
#
#   inherited from OpenMS:
#			- test for contrib headers (CONTRIB_HEADER_DIR ccmake variable - test one header for each required library)
#			- parallel build of test executables
#			- target to execute all EXAMPLES

########################################################
### entries meant to be configured using CMake cache ###
### - do NOT hardcode them here!										 ###
### - edit them within CMakeCache.txt using ccmake	 ###
########################################################
# BALL_BUILD_TYPE
# CONTRIB_CUSTOM_DIR
# STL_DEBUG
# QT_DB_PLUGIN
# MT_CUDA_BUILD_TYPE

########################################################
###    manual entries (edit this for new release)    ###
########################################################

SET(BALL_PACKAGE_VERSION_MAJOR "1")
SET(BALL_PACKAGE_VERSION_MINOR "4")
SET(BALL_PACKAGE_VERSION_PATCH "0")

########################################################
###    end manual	entries													   ###
########################################################

# Heart of the BUILD system : only edit when you know what you�re doing (we don�t)
# quick manual for most commands: http://www.cmake.org/cmake/help/cmake2.6docs.html
# useful predefined variables: http://www.paraview.org/Wiki/CMake_Useful_Variables

CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)

SET(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)

SET(CMAKE_CXX_OUTPUT_EXTENSION_REPLACE TRUE)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

OPTION(BALL_USE_PROJECT_FOLDERS ON)
IF (BALL_USE_PROJECT_FOLDERS)
	SET(USE_FOLDERS TRUE)
ENDIF()

SET(CF_BALL_PACKAGE_VERSION "${BALL_PACKAGE_VERSION_MAJOR}.${BALL_PACKAGE_VERSION_MINOR}.${BALL_PACKAGE_VERSION_PATCH}" CACHE INTERNAL "BALL VERSION" FORCE)

# Initialize the various PREFIX variables. This has to happen before any files
# using them are included.
#SET(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "Installation prefix for BALL")

## default build type (for Makefile generators): Release
## TODO: 64 Bit builds etc for Windows
SET(BALL_BUILD_TYPE "Release" CACHE STRING "Build type: 'Debug' or 'Release'")

IF ("${BALL_BUILD_TYPE}" STREQUAL "Debug")
	MESSAGE(STATUS "BALL build type: ${BALL_BUILD_TYPE} (compiler debug info and BALL debug mode enabled)")
	SET(CMAKE_BUILD_TYPE "Debug" CACHE INTERNAL "This must be equal to BALL_BUILD_TYPE!" FORCE)
ELSEIF ("${BALL_BUILD_TYPE}" STREQUAL "Release")
	MESSAGE(STATUS "BALL build type: ${BALL_BUILD_TYPE} (optimization enabled)")
	SET(CMAKE_BUILD_TYPE "Release" CACHE INTERNAL "This must be equal to BALL_BUILD_TYPE!" FORCE)
ELSE()
	MESSAGE(FATAL_ERROR "BALL_BUILD_TYPE must be 'Debug' or 'Release'!")
ENDIF()

SET(BALL_CONTRIB_PATH "" CACHE PATH "Path to the contrib directory, if installed (optional)")
SET(CMAKE_PREFIX_PATH ${BALL_CONTRIB_PATH} ${CMAKE_PREFIX_PATH})

SET(CMAKE_REQUIRED_INCLUDES ${BALL_CONTRIB_PATH}/include ${CMAKE_REQUIRED_INCLUDES})

SET(BALL_TEST_DATA_PATH ${PROJECT_SOURCE_DIR}/source/TEST/data)
SET(BALL_BENCHMARK_DATA_PATH ${PROJECT_SOURCE_DIR}/source/BENCHMARKS/data)

# Should we build packages as well?
OPTION(BALL_ENABLE_PACKAGING "Enable the building of binary packages" OFF)

# Used for linking BALL dependent applications and libraries (BALLView, Python bindings, ...)
SET(BALL_LIBRARIES optimized BALL debug BALLd)
SET(VIEW_LIBRARIES optimized VIEW debug VIEWd)

# some of our own macros (BALL_CHECKLIB, QT4_WRAP_UI_OWN, ...)
INCLUDE(cmake/BALLMacros.cmake)
INCLUDE(cmake/BALLCompilerSpecific.cmake)
INCLUDE(cmake/BALLConfiguration.cmake)
INCLUDE(cmake/BALLComponents.cmake)

## additional include directories
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include/) ## for configured files, i.e. config.h
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/include/)
INCLUDE_DIRECTORIES(${BALL_CONTRIB_PATH}/include/)

## Extra libraries we want to link into BALL
SET(BALL_DEP_LIBRARIES)
SET(VIEW_DEP_LIBRARIES)

## Flex and Bison
## This ugly hack is required as long as we cannot tell cmake to set an environment variable for bison...
IF (WIN32)
	FIND_PROGRAM(BISON_EXECUTABLE BALL-bison.bat DOC "path to the bison executable")
ENDIF()
FIND_PACKAGE(BISON)
IF (NOT BISON_FOUND)
	MESSAGE(SEND_ERROR "Could not find bison parser generator!")
ENDIF()

IF (WIN32)
	SET(BALL_BISON_BAT ${BISON_EXECUTABLE})
	SET(BISON_EXECUTABLE "call")
ENDIF()

FIND_PACKAGE(FLEX)
IF (NOT FLEX_FOUND)
	MESSAGE(SEND_ERROR "Could not find flex scanner generator!")
ENDIF()

## Third-party libraries ##

## XDR related stuff
FIND_PACKAGE(XDR)
IF (XDR_FOUND)
	INCLUDE(cmake/BALLConfigXDR.cmake)
ENDIF()

## Boost and Asio
INCLUDE(cmake/BALLConfigBoost.cmake)
INCLUDE_DIRECTORIES(${BOOST_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
LIST(APPEND BALL_DEP_LIBRARIES ${BOOST_LIBRARIES})
# make the rest of CMake aware of boost's existence
LIST(APPEND CMAKE_REQUIRED_INCLUDES ${BOOST_INCLUDE_DIRS})

## Find a suitable hash map implementation (or fall back to map)
INCLUDE(cmake/BALLConfigHashMap.cmake)

## GSL
FIND_PACKAGE(GSL)
IF (NOT GSL_FOUND)
	MESSAGE(SEND_ERROR "gsl is required for BALL but could not be found!")
ELSE()
	ADD_DEFINITIONS(${CMAKE_GSL_CXX_FLAGS})
	INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIR})
	LIST(APPEND BALL_DEP_LIBRARIES ${GSL_LIBRARIES})
ENDIF()

## BLAS
FIND_PACKAGE(BLAS)
IF (BLAS_FOUND)
	SET(BALL_HAS_BLAS TRUE)
	INCLUDE_DIRECTORIES(${BLAS_INCLUDE_DIR})
	LIST(APPEND BALL_DEP_LIBRARIES ${BLAS_LIBRARIES})
ENDIF()

## LAPACK
FIND_PACKAGE(LAPACK)
IF (LAPACK_FOUND)
	SET(BALL_HAS_LAPACK TRUE)
	INCLUDE_DIRECTORIES(${LAPACK_INCLUDE_DIR})
	LIST(APPEND BALL_DEP_LIBRARIES ${LAPACK_LIBRARIES})
ENDIF()

## FFTW
OPTION(USE_FFTWD "Use double precision FFTW if found" ON)
OPTION(USE_FFTWF "Use single precision FFTW if found" ON)
OPTION(USE_FFTWF "Use long double precision FFTW if found" ON)
OPTION(USE_FFTW_THREADS "Try to find FFTW with thread support" OFF)

FIND_PACKAGE(FFTW)
IF(FFTW_FOUND)
	INCLUDE(cmake/BALLConfigFFTW.cmake)
ENDIF()

#Set the default complex precision to float if the setting for this value
#could not be determined earlier
IF(NOT BALL_COMPLEX_PRECISION)
	SET(BALL_COMPLEX_PRECISION "float")
ENDIF()

## lpsolve
OPTION(USE_LPSOLVE "Compile with lpsolve support, if lpsolve can be found" ON)

FIND_PACKAGE(LPSolve)
IF (LPSOLVE_FOUND)
	SET(BALL_HAS_LPSOLVE TRUE)
	INCLUDE_DIRECTORIES(${LPSOLVE_INCLUDE_DIR})
ENDIF()

## VRPN
FIND_PACKAGE(VRPN)
IF (VRPN_FOUND)
	SET(BALL_HAS_VRPN TRUE)
	INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR})
ENDIF()

## libsvm
OPTION(USE_LIBSVM "Compile with libsvm support if libsvm can be found" ON)

FIND_PACKAGE(libSVM)
IF (LIBSVM_FOUND)
	SET(BALL_HAS_LIBSVM TRUE)
	INCLUDE_DIRECTORIES(${LIBSVM_INCLUDE_DIRS})
ENDIF()

## CUDA
SET(MT_ENABLE_CUDA OFF CACHE BOOL "Should CUDA support be enabled (version <= 2.1 currently supported).")

IF(MT_ENABLE_CUDA)
	FIND_PACKAGE(CUDA REQUIRED)
ENDIF()

## TBB
SET(MT_ENABLE_TBB OFF CACHE BOOL "Should Intel Threading Building Blocks support be enabled.")

IF(MT_ENABLE_TBB)
	FIND_PACKAGE(TBB REQUIRED)
	INCLUDE_DIRECTORIES(${TBB_INCLUDE_DIRS})
	BALL_COMBINE_LIBS(TBB_LIBRARIES "${TBB_LIBRARIES}" "${TBB_DEBUG_LIBRARIES}")
ENDIF()

## MPI
OPTION(MT_ENABLE_MPI "Should MPI support be enabled.")

IF (MT_ENABLE_MPI)
	FIND_PACKAGE(MPI REQUIRED)

	ADD_DEFINITIONS(${MPI_COMPILE_FLAGS})
	INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})

	SET(BALL_HAS_MPI TRUE)
ENDIF()

## VIEW related options/settings/libraries
OPTION(BALL_HAS_VIEW "Compile BALL's VIEW library required for visualization and graphical user interfaces" ON)

## QT
OPTION(BALL_HAS_QTSQL "Compile BALL's database adapaters (requires QtSql)" ON)

FIND_PACKAGE(Qt4 REQUIRED)

SET(QT_USE_QTXML TRUE)
SET(QT_USE_QTNETWORK TRUE)
SET(QT_USE_QTSQL ${BALL_HAS_QTSQL})
SET(QT_USE_QTOPENGL TRUE)
SET(QT_USE_QTTEST TRUE)
SET(QT_MIN_VERSION "4.4.0")

IF (NOT BALL_HAS_VIEW)
	SET(QT_DONT_USE_QTGUI TRUE)
ENDIF()

INCLUDE(${QT_USE_FILE})

MESSAGE(STATUS "QT qmake at ${QT_QMAKE_EXECUTABLE}")
MESSAGE(STATUS "QT moc at ${QT_MOC_EXECUTABLE}")
MESSAGE(STATUS "QT uic at ${QT_UIC_EXECUTABLE}")

## VIEW dependent packages
IF (BALL_HAS_VIEW)

	## OpenGL
	FIND_PACKAGE(OpenGL)
	IF (NOT OPENGL_FOUND OR NOT OPENGL_GLU_FOUND)
		MESSAGE(SEND_ERROR "Could not find gl/glu!")
	ENDIF()

	## GLEW
	FIND_PACKAGE(GLEW)
	IF (GLEW_FOUND)
		SET(BALL_HAS_GLEW TRUE)
	ENDIF()

ENDIF(BALL_HAS_VIEW)

## Python
OPTION(BALL_PYTHON_SUPPORT "Compile BALL's python interface (requires python development packages)" ON)

IF (BALL_PYTHON_SUPPORT)
	FIND_PACKAGE(PythonInterp)
	IF (PYTHONINTERP_FOUND)
		FIND_PACKAGE(PythonLibs)
		IF (PYTHONLIBS_FOUND)
			BALL_COMBINE_LIBS(PYTHON_LIBRARIES "${PYTHON_LIBRARIES}" "${PYTHON_DEBUG_LIBRARIES}")
			FIND_PACKAGE(SIP)
			SET(BALL_SIP_VERSION ${SIP_VERSION})
			SET(BALL_SIP_VERSION_STR ${SIP_VERSION_STR})
		ENDIF()
	ENDIF()

	IF (NOT PYTHONINTERP_FOUND OR NOT PYTHONLIBS_FOUND OR NOT SIP_FOUND)
		SET(BALL_PYTHON_SUPPORT OFF)
		MESSAGE(WARNING "Disabling python support.")
	ELSE()
		INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
		INCLUDE_DIRECTORIES(${SIP_INCLUDE_DIR})
	ENDIF()
ENDIF()

## On Windows, we might need a seperate regex2-lib
IF (WIN32)
	IF (NOT BALL_HAS_BOOST_REGEX)
		FIND_LIBRARY(REGEX_LIBRARIES
			NAMES regex2 regex
			PATH_SUFFIXES lib dlls
			DOC "Regular expressions library")

		IF (NOT REGEX_LIBRARIES)
			MESSAGE(SEND_ERROR "Could not find required regex2.lib!")
		ENDIF()
	ELSE()
		SET(REGEX_LIBRARIES "")
	ENDIF()
ENDIF()


OPTION(BALL_BUILD_QUEASY "Build BALL with QSAR frontends" OFF)

IF (BALL_BUILD_QUEASY)
	FIND_PACKAGE(Qwt5 REQUIRED)
	
	SET(QWT_LIBRARIES ${Qwt5_Qt4_LIBRARY})
ENDIF ()

## replace any variables in config.h.in with current values
SET(CONFIGURED_CONFIG_H ${PROJECT_BINARY_DIR}/include/BALL/CONFIG/config.h)
CONFIGURE_FILE(cmake/config.h.in ${CONFIGURED_CONFIG_H})

## build a config.h file for the python support to not disturb the
## rest of BALL
CONFIGURE_FILE(cmake/BALLPythonConfig.h.in ${PROJECT_BINARY_DIR}/include/BALL/PYTHON/BALLPythonConfig.h)

## build a config.h file for our tests to not disturb the rest of BALL
CONFIGURE_FILE(cmake/BALLTestConfig.h.in ${PROJECT_BINARY_DIR}/source/TEST/BALLTestConfig.h)

## build a config.h file for our benchmarks to not disturb the rest of BALL
CONFIGURE_FILE(cmake/BALLBenchmarkConfig.h.in ${PROJECT_BINARY_DIR}/source/BENCHMARKS/BALLBenchmarkConfig.h)

ADD_DEFINITIONS(${BALL_DEFINITIONS})

SET(BALL_EXECUTABLES "")
########################################################
###    BUILD the lib																 ###
########################################################

## are we building a shared or static lib?! (BOTH within 
## the same BUILD-tree is NOT possible currently!!)
SET(BUILD_SHARED_LIBS TRUE)

SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib")
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

## These variables are used in all install-targets
IF (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET(BALL_RUNTIME_INSTALL_DIRECTORY "bin")
	SET(BALL_LIBRARY_INSTALL_DIRECTORY "lib")
	SET(BALL_ARCHIVE_INSTALL_DIRECTORY "lib")
	SET(BALL_HEADER_INSTALL_DIRECTORY   ".")
	SET(BALL_DATA_INSTALL_DIRECTORY    "share/BALL")
	SET(BALL_DOCUMENTATION_INSTALL_DIRECTORY    "share/BALL/doc")
	IF(WIN32)
		SET(BALL_PYTHON_INSTALL_DIRECTORY  "bin")
		SET(BALL_PLUGIN_INSTALL_DIRECTORY  "bin")
	ELSE()
		SET(BALL_PYTHON_INSTALL_DIRECTORY  "lib")
		SET(BALL_PLUGIN_INSTALL_DIRECTORY  "lib")
	ENDIF()
ELSE()
	SET(BALL_BUNDLE_INSTALL_DIRECTORY  					"Applications")
	SET(BALL_RUNTIME_INSTALL_DIRECTORY 					"Applications/BALLView.app/Contents/Frameworks")
	SET(BALL_LIBRARY_INSTALL_DIRECTORY 					"Applications/BALLView.app/Contents/Frameworks")
	SET(BALL_ARCHIVE_INSTALL_DIRECTORY 					"Applications/BALLView.app/Contents/Frameworks")

=== TEST/CMakeLists.txt ===
### Build rules for BALL's class tests
PROJECT("BALL_tests")

ENABLE_TESTING()

OPTION(BALL_TEST_VERBOSE "Use verbose output for the tests" ON)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/TEST)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

## For now, disable optimization for the tests
IF (CMAKE_COMPILER_IS_INTELCXX OR CMAKE_COMPILER_IS_GNUCXX)
	SET(CMAKE_CXX_FLAGS_RELEASE_SAVED ${CMAKE_CXX_FLAGS_RELEASE})
	SET(CMAKE_CXX_FLAGS_RELEASE "-O0")
ENDIF()

INCLUDE(cmake/BALLTestExecutables.cmake)
INCLUDE(cmake/VIEWTestExecutables.cmake)

## BASIC
ADD_CUSTOM_TARGET(BASIC_TEST)
ADD_DEPENDENCIES(BASIC_TEST ${BALL_BASIC_TESTS})

## MATHS
ADD_CUSTOM_TARGET(MATHS_TEST)
ADD_DEPENDENCIES(MATHS_TEST ${BALL_MATHS_TESTS})

## SYSTEM
ADD_CUSTOM_TARGET(SYSTEM_TEST)
ADD_DEPENDENCIES(SYSTEM_TEST ${BALL_SYSTEM_TESTS})

## TODO: all of them...

## Restore build flags
IF (CMAKE_COMPILER_IS_INTELCXX OR CMAKE_COMPILER_IS_GNUCXX)
	SET(${CMAKE_CXX_FLAGS_RELEASE} ${CMAKE_CXX_FLAGS_RELEASE_SAVED})
ENDIF()


# Now, add all tests as targets
SET(ALL_TESTS "")
FOREACH(group ${BALL_TESTS})
	FOREACH(test ${${group}})
		IF (WIN32)
			# Workaround for the stupid MSVC
			ADD_EXECUTABLE(${test} ${test}.C stringStub.C)
		ELSE()
			ADD_EXECUTABLE(${test} ${test}.C)
		ENDIF()
		TARGET_LINK_LIBRARIES(${test} BALL)
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER ${group})
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
		LIST(APPEND ALL_TESTS ${test})
	ENDFOREACH()
ENDFOREACH()

IF (BALL_HAS_VIEW)
	FOREACH(test ${VIEW_TESTS})
		IF (WIN32)
			# Workaround for the stupid MSVC
			ADD_EXECUTABLE(${test} ${test}.C stringStub.C)
		ELSE()
			ADD_EXECUTABLE(${test} ${test}.C)
		ENDIF()
		TARGET_LINK_LIBRARIES(${test} BALL VIEW)
		SET_PROPERTY(TARGET ${test} PROPERTY FOLDER BALL_VIEW_TESTS)
		IF (NOT BALL_TEST_VERBOSE)
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test})
		ELSE()
			ADD_TEST(${test} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${test} "-v")
		ENDIF()
	ENDFOREACH()

	LIST(APPEND ALL_TESTS ${VIEW_TESTS})
ENDIF()

# Create a suitable target
ADD_CUSTOM_TARGET(build_tests)
ADD_DEPENDENCIES(build_tests ${ALL_TESTS})

=== APPLICATIONS/BALLVIEW/CMakeLists.txt ===
PROJECT(BALLView)

### list all filenames of the directory here ###
SET(SOURCES_LIST
	demoTutorialDialog.C
	icons.C
	main.C
	mainframe.C
)

### the list of all files requiring a moc run ###
SET(MOC_SOURCES_LIST
	demoTutorialDialog.h
	mainframe.h
)

SET(UI_SOURCES_LIST
	aboutDialog.ui
	demoTutorialDialog.ui
)

SET(RCC_SOURCES_LIST
	splashscreen.qrc
)

SET(RESOURCES_LIST
	BALLView.rc
)

IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	LIST(APPEND RESOURCES_LIST ${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns)
	SET(MACOSX_BUNDLE_ICON_FILE BALLView.icns)
	SET_SOURCE_FILES_PROPERTIES(${CMAKE_SOURCE_DIR}/cmake/installer/BALLView.icns
			PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF()

QT4_WRAP_CPP(MOC_OUTFILES ${MOC_SOURCES_LIST})
QT4_ADD_RESOURCES(RCC_OUTFILES ${RCC_SOURCES_LIST})
QT4_WRAP_UI(UIC_OUTFILES ${UI_SOURCES_LIST})

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR})

ADD_EXECUTABLE(BALLView
	${SOURCES_LIST}
	${MOC_OUTFILES}
	${RCC_OUTFILES}
	${UIC_OUTFILES}
	${RESOURCES_LIST}
)

IF (WIN32)
	SET_TARGET_PROPERTIES(BALLView PROPERTIES WIN32_EXECUTABLE TRUE)
ELSEIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	SET_TARGET_PROPERTIES(BALLView PROPERTIES MACOSX_BUNDLE TRUE)
ENDIF()

INSTALL(TARGETS BALLView
	COMPONENT "${COMPONENT_BALLVIEW}"
	RUNTIME DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
	BUNDLE DESTINATION "${BALL_BUNDLE_INSTALL_DIRECTORY}"
)

INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/internal 
	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
	COMPONENT "${COMPONENT_BALLVIEW}"
)

INSTALL(DIRECTORY ${CMAKE_SOURCE_DIR}/doc/BALLView 
	DESTINATION "${BALL_DOCUMENTATION_INSTALL_DIRECTORY}" 
	COMPONENT "${COMPONENT_BALLVIEW}"
)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	GET_FILENAME_COMPONENT(MACDEPLOYQT_EXECUTABLE "${QT_QMAKE_EXECUTABLE}" PATH)
	SET(MACDEPLOYQT_EXECUTABLE "${MACDEPLOYQT_EXECUTABLE}/macdeployqt")
	INSTALL(CODE "SET(MACDEPLOYQT_EXECUTABLE \"${MACDEPLOYQT_EXECUTABLE}\")" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(CODE "SET(FIXBUNDLE ${CMAKE_SOURCE_DIR}/MacOSX/fixbundleframeworks.sh)" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(CODE "SET(BALLVIEW_BUNDLE \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${BALL_BUNDLE_INSTALL_DIRECTORY}/BALLView.app\")" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(CODE "SET(CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR})" COMPONENT "${COMPONENT_BALLVIEW}")
	INSTALL(SCRIPT "${CMAKE_SOURCE_DIR}/cmake/BALLViewCreateBundle.cmake" COMPONENT "${COMPONENT_BALLVIEW}")
ENDIF()

TARGET_LINK_LIBRARIES(BALLView BALL VIEW)

#Setup the translations
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/BALLViewTranslations.cmake)

=== PYTHON/EXTENSIONS/CMakeLists.txt ===
PROJECT(BALLPython)

IF(BALL_PYTHON_SUPPORT)
	INCLUDE(SIPMacros)

	REMOVE_DEFINITIONS(-pedantic)

	INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

	IF(NOT BALL_HAS_ASIO)
		SET(SIP_DISABLE_FEATURES "BALL_HAS_ASIO")
	ENDIF()
	SET(SIP_EXTRA_OPTIONS "-e")

	FILE(GLOB BALL_SIP_DEPENDS "BALL/*.sip")
	FILE(GLOB VIEW_SIP_DEPENDS "VIEW/*.sip")

	SET(SIP_EXTRA_FILES_DEPEND ${BALL_SIP_DEPENDS} ${VIEW_SIP_DEPENDS})

	# Add the BALLCore python bindings
	SET(SIP_EXTRA_SOURCES 
		BALL/pyBALLSipHelper.C
		BALL/pyIndexList.C
		BALL/pyConstant.C
	)
	ADD_SIP_PYTHON_MODULE(BALLCore BALLCoremodule BALL/BALLCore.sip BALL)
	
	SET(SIP_EXTRA_SOURCES
		VIEW/pyCompositeList.C
		VIEW/pyBALLSipHelper.C
		VIEW/pyColorRGBAVector.C
		VIEW/pyDatasetVector.C
	)
	# Add the VIEW python bindings
	SET(SIP_INCLUDES ${PROJECT_SOURCE_DIR})
	ADD_SIP_PYTHON_MODULE(VIEW VIEWmodule VIEW/VIEW.sip BALL VIEW)

	# Install the BALL.py script
	IF(NOT WIN32)
		SET(BALL_PY_LOCATION ${CMAKE_LIBRARY_OUTPUT_DIRECTORY})
	ELSE()
		SET(BALL_PY_LOCATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR})

	ENDIF()

	ADD_CUSTOM_COMMAND(TARGET BALLCoremodule POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/BALL.py ${BALL_PY_LOCATION}
	)

	INSTALL(TARGETS BALLCoremodule
		COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
		RUNTIME DESTINATION ${BALL_RUNTIME_INSTALL_DIRECTORY}
		LIBRARY DESTINATION ${BALL_LIBRARY_INSTALL_DIRECTORY}
	)

	INSTALL(TARGETS VIEWmodule
		COMPONENT "${COMPONENT_PYTHON_BINDINGS_VIEW}"
		RUNTIME DESTINATION ${BALL_RUNTIME_INSTALL_DIRECTORY}
		LIBRARY DESTINATION ${BALL_LIBRARY_INSTALL_DIRECTORY}
	)

	INSTALL(FILES ${PROJECT_SOURCE_DIR}/BALL.py 
		COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
		DESTINATION "${BALL_PYTHON_INSTALL_DIRECTORY}"
	)
	
	IF (WIN32)
		INSTALL(FILES ${PYTHON_EXECUTABLE}
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
		)
		
		GET_FILENAME_COMPONENT(PYTHON_SITE_PACKAGES_DIR ${PYTHON_EXECUTABLE} PATH) 
		SET(PYTHON_SITE_PACKAGES_DIR "${PYTHON_SITE_PACKAGES_DIR}/lib")
		
		INSTALL(DIRECTORY "${PYTHON_SITE_PACKAGES_DIR}"
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_RUNTIME_INSTALL_DIRECTORY}"
		)
		
	ENDIF ()

	IF (APPLE)
		INSTALL(FILES ${SIP_LIBRARIES}
			COMPONENT "${COMPONENT_PYTHON_BINDINGS_BALL}"
			DESTINATION "${BALL_PYTHON_INSTALL_DIRECTORY}"
		)
	ENDIF()

ENDIF()

=== debian/changelog ===
ball (1.4.0-4) unstable; urgency=low

  * Documentation packages are in conflict with past version
    (Closes: #631911)
  * Removed (redundant) conflict of ballview to itself
  * Helped quirk in descrition (Closes: #598081)

 -- Steffen Moeller <moeller@debian.org>  Fri, 22 Jul 2011 16:41:02 +0200

ball (1.4.0-3) unstable; urgency=low

  * Added -fpermissive to compiler flags to avoid "narrowing" error

 -- Steffen Moeller <moeller@debian.org>  Wed, 20 Jul 2011 17:47:51 +0200

ball (1.4.0-2) unstable; urgency=low

  * Addressing build failures (Closes: #615670, #631999)
    - removed -j2 in build instructions (Closes: #632483)
    - added texlive-recommends not covered by doxygen-latex

 -- Steffen Moeller <moeller@debian.org>  Wed, 20 Jul 2011 15:19:18 +0200

ball (1.4.0-1) unstable; urgency=low

  [Andreas]
  * Updated to new upstream release 1.4.0
  * Cherry-pick upstream patch for linguist files
  * Cherry-pick upstream patch for new DSO linking scheme
  * Updated policy to 3.9.2
  * Split out arch-independent data package
  * Depend on libgl1-mesa-glx instead of libgl1-mesa-swx11
  * Introduce suitable conflicts against older versions where necessary
  * Install cmake BALL exports and config
  * build-depend on doxygen-latex instead of texlive-* (Closes: 616200)
  * Split build dependencies into Build-Deps and Build-Deps-Indep
  [Steffen]
  * Moved all build instructions to debian/rules.
  * Corrected email address

 -- Andreas Hildebrandt <ahildebr@uni-mainz.de>  Tue, 21 Jun 2011 18:29:51 +0200

ball (1.3.2-3) UNRELEASED; urgency=low

  [Steffen Moeller]
  * Updated policy to 3.8.4 (no changes required)
  * Added libgl1-mesa-swx11 explicitly as a dependency to ballview
  [Andreas Hildebrandt]
  * Depend on python-sip-dev instead of python-sip4-dev (Closes: #611072)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Tue, 01 Mar 2011 08:30:58 +0100

ball (1.3.2-2) unstable; urgency=low

  [Andreas Hildebrandt]
  * Improvements for CMake build system (Closes: 546311)
  * Some fixes for less common architectures and fixes in the sip dependencies
   (Closes: 565694)
  [Jonathan Wiltshire]
  * Depend on python-support and call dh_pysupport in debian/rules.
    Let python-support decide dependencies for python-ball and python-ballview.
    (Closes: #566036)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 11 Feb 2010 22:15:09 +0100

ball (1.3.2-1) unstable; urgency=low

  * Updated to new upstream release 1.3.2

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Tue, 19 Jan 2010 12:34:33 +0100

ball (1.3.1-2) unstable; urgency=low

  * Add python-sip4 as an explicit build-dependency (fixes an FTBFS)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Tue, 12 Jan 2010 10:25:36 +0100

ball (1.3.1-1) unstable; urgency=low

  * Updated to new upstream release 1.3.1 (Closes: 551241)
  * Switched from autoconf to CMake (Closes: 552809)

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Fri, 18 Dec 2009 14:20:08 +0100

ball (1.3.0-2) UNRELEASED; urgency=low

  [ Andreas Hildebrandt ]
  * Increased dependency to python-sip4 to version 4.8.2, which
    would need to be adjusted for lenny (4.7.2). The real (unexpressable)
    dependency is to have the same version at build- and run-time.  [Steffen]

  [ Charles Plessy ]
  * Documented informations in ‘debian/upstream-metadata.yaml’.

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 17 Sep 2009 22:30:28 +0200

ball (1.3.0-1) unstable; urgency=low

  * New upstream release 
  * BALL no longer uses gSoap (Closes: #542215)
  * Added s390 to list of supported processors (Closes: #546311)
  * Fixed broken maintainer address (Closes: #544932)
  * Updated policy-compliance to 3.8.3 (no changes reguired)
  * Updated build-dependencies to demand more recent libtool

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 17 Sep 2009 22:30:28 +0200

ball (1.3+rc2-1) unstable; urgency=low

  * Removed debian/copyright entries for files no longer in the repository
  * Updated to new upstream release candidate
  * Removed build-dependency on libboost-asio-dev (Closes: #542251)
  * Some small packaging improvements

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Thu, 17 Sep 2009 22:25:51 +0200

ball (1.3+beta2.1-2) unstable; urgency=low

  * Re-upload upon initial rejection to improve debian/copyright (Closes: #407665)
  * Improved Doc-Base 
  * Eliminated two lintian warnings

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Sun, 16 Aug 2009 01:23:30 +0200

ball (1.3+beta2.1-1) UNRELEASED; urgency=low

  * Preparing for new upstream version 1.3 (Closes: #407665)
  * Improvements for Debian packaging
    - providing VIEW-independent and -dependent debs
    - corrected for problematic copyright statements

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Mon, 6 Jul 2009 17:43:00 +0100

ball (1.2-1) UNRELEASED; urgency=low

  * Initial packaging

 -- Andreas Hildebrandt <anhi@bioinf.uni-sb.de>  Sun, 16 Nov 2008 20:24:32 +0100

=== debian/control ===
Source: ball
Section: science
Priority: optional
Maintainer: Andreas Hildebrandt <ahildebr@uni-mainz.de>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 5), 
 qt4-dev-tools, libqt4-dev, libqt4-gui, libqt4-opengl,
 libqt4-opengl-dev, libqt4-sql, libqt4-network, 
 python-sip-dev (>= 4.8.2), flex, bison, cmake, libglew1.5-dev|libglew-dev, 
 libfftw3-dev, libgsl0-dev, python-dev (>= 2.4), libxrender-dev,
 libboost-dev, libboost-iostreams-dev, libboost-thread-dev, 
 libboost-math-dev | libboost-dev (<< 1.37), libboost-system-dev | libboost-dev (<< 1.37),
 libasio-dev, libboost-regex-dev, libxmu-dev, tidy,
 gs-common, graphviz, chrpath, python-support (>= 0.90.0)
Build-Depends-Indep: texlive-fonts-recommended,
 doxygen-latex|doxygen, doxygen-latex|latex-xcolor,
 doxygen-latex|texlive-extra-utils, doxygen-latex|texlive-latex-extra
XS-Python-Version: all
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/debian-med/ball.git
Vcs-Browser: http://git.debian.org/?p=debian-med/ball.git
Homepage: http://www.ballview.org

Package: libball1.4-data
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the data files (force field parameters, fragment
 data bases, etc) necessary for using BALL.

Package: libball1.4
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libball1.4-data
Description: Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view - independent parts of BALL (libBALL,
 data directories et al., except for libVIEW) and can be installed on
 machines without X11.

Package: libball1.4-dev
Section: libdevel
Architecture: any
Depends: libball1.4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libball1.3-dev
Recommends: libball1.4-doc
Description: Header files for the Biochemical Algorithms Library
 This package comprises the header files allowing to create
 one's own applications with the BALL library.

Package: libballview1.4
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Biochemical Algorithms Library, VIEW framework
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 It provides an extensive set of data structures as well as classes 
 for Molecular Mechanics, advanced solvation methods, comparison and 
 analysis of protein structures, file import/export, and visualization.
 BALL is currently being developed in the groups of Oliver Kohlbacher
 (University of Tuebingen, Germany), Andreas Hildebrandt (Saarland 
 University, Saarbruecken, Germany), and Hans-Peter Lenhof (Saarland 
 University, Saarbruecken, Germany).
 .
 This package contains the view parts of BALL (libVIEW). Those are
 required for molecular visualization and for running BALLView.

Package: libballview1.4-dev
Section: libdevel
Architecture: any
Depends: libballview1.4 (= ${binary:Version}), ${misc:Depends}
Conflicts: libballview1.3-dev
Recommends: libball1.4-doc
Description: Header files for the VIEW part of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package comprises the header files allowing to create one's own 
 applications with the VIEW framework of the BALL library.

Package: python-ball
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${sip:Depends}, 
 libball1.4, ${misc:Depends}
Conflicts: python-ball (<< ${binary:Version})
Description: Python bindings for the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-independent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: python-ballview
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${python:Depends}, ${sip:Depends}, 
 libball1.4, libballview1.4, python-ball (= ${binary:Version}), ${misc:Depends}
Conflicts: python-ballview (<< ${binary:Version})
Description: Python bindings for VIEW-parts of the Biochemical Algorithms Library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 This package provides scripting access to the VIEW-dependent functionality 
 of the Biochemical Algorithms Library (BALL).

Package: ballview
Section: science
Architecture: any
Depends: ${shlibs:Depends}, libgl1-mesa-glx|libgl1, libball1.4, libballview1.4, python-ball,
 python-ballview, ${misc:Depends}
Description: free molecular modeling and molecular graphics tool
 BALLView provides fast OpenGL-based visualization of molecular structures, 
 molecular mechanics methods (minimization, MD simulation using the 
 AMBER, CHARMM, and MMFF94 force fields), calculation and visualization 
 of electrostatic properties (FDPB) and molecular editing features.
 .
 BALLView can be considered a graphical user interface on the basis of
 BALL (Biochemical Algorithms Library) with a focus on the most common
 demands of protein chemists and biophysicists in particular.  It is
 developed in the groups of Hans-Peter Lenhof (Saarland University,
 Saarbruecken, Germany) and Oliver Kohlbacher (University of Tuebingen,
 Germany). BALL is an application framework in C++ that has been
 specifically designed for rapid software development in Molecular
 Modeling and Computational Molecular Biology.  It provides an extensive
 set of data structures as well as classes for Molecular Mechanics,
 advanced solvation methods, comparison and analysis of protein
 structures, file import/export, and visualization.

Package: libball1.4-doc
Architecture: all
Section: doc
Depends: libball1.4, ${misc:Depends}
Conflicts: libball1.3-doc
Description: documentation for the BALL library
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.

Package: ballview-dbg
Architecture: any
Priority: extra
Section: debug
Depends: python-ballview, ballview, ${misc:Depends}
Description: debug symbols for BALL and VIEW libraries
 BALL (Biochemical Algorithms Library) is an application framework 
 in C++ that has been specifically designed for rapid software 
 development in Molecular Modeling and Computational Molecular Biology. 
 The package comprises an extensive manual on how to program molecular
 modelling programs with BALL.
 .
 This package contains all the extra information on the libraries of
 BALL, BALLView and the Python wrappers to help debuggers like GDB to
 interpret a core dump. This is tremendously useful for debugging and
 maybe even more so for the communication between the user of this
 package and upstream when something goes wrong.

=== debian/rules ===
#!/usr/bin/make -f 
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export CFLAGS = -Wall -g -Wno-unused-variable -fpermissive
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
export CPPFLAGS=$(CFLAGS)

SOVERSION=1.4
BALL_INSTALL_PATH=build
PYTHON_VERSION=2.6
PYTHON_SITE_PATH=$(shell python -c "import distutils.sysconfig; print distutils.sysconfig.get_python_lib(0,0)[4:];")

configure: configure-stamp
configure-stamp:
	dh_testdir
	#bash debian/debian-ball-install configure
	mkdir build
	cd build && CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" cmake .. -DCMAKE_SOURCE_DIR=$(CURDIR) -DCMAKE_INSTALL_PREFIX=./usr -DBALL_PATH=/usr -DBALL_DATA_PATH=/usr/share/BALL-$(SOVERSION)/data
	touch $@

#build: build-stamp 
#build-stamp: build-arch-stamp build-indep-stamp
#	touch $@

build:
	echo "Please call either build-arch or build-indep"

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp
	dh_testdir
	#bash debian/debian-ball-install build-arch
	make -C build BALL VIEW BALLView install
	touch $@

# The arch dependent bits need to be uilt also for the independent bits
build-indep: build-arch-stamp build-indep-stamp
build-indep-stamp: configure-stamp
	dh_testdir
	#bash debian/debian-ball-install build-arch
	make -C build doc doc_tutorial install
	touch $@

clean:
	dh_testdir
	dh_testroot
	#bash debian/debian-ball-install clean
	[ -d source ] && cd source ; \
	if [ -f Makefile ] ; \
	then  \
		make clean ; \
		cd PYTHON/EXTENSIONS; \
		make clean; \
		rm -rf ../lib/Linux*; \
		rm -rf ../doc/doxygen/latex/*; \
		rm -f $(CURDIR)/source/config.status 2>/dev/null; \
	fi
	rm -f data/BALLView/translations/BALLView.de_DE.qm
	rm -f data/BALLView/translations/BALLView.zh_TW.qm
	rm -f doc/TUTORIAL/*.aux
	rm -rf $(BALL_INSTALL_PATH)
	find . -name "*.o" | xargs -r rm
	find . -type l | xargs -r rm
	find doc/TUTORIAL/ -name "tutorial.*" | egrep -v ".(tex|bib)$$" |xargs -r rm 

	dh_clean build-stamp configure-stamp build-arch-stamp build-indep-stamp

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	mkdir -p debian/libball$(SOVERSION)/usr/lib \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION) \
		debian/libballview$(SOVERSION)/usr/lib \
		debian/python-ball/usr/share/BALL-$(SOVERSION) \
		debian/python-ball/usr/$(PYTHON_SITE_PATH) \
		debian/python-ballview/usr/$(PYTHON_SITE_PATH)

	mkdir -p debian/ballview/usr/share/BALL-$(SOVERSION)/data/graphics

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/BALLView/* debian/ballview/usr/share/doc/ballview/html
	cp    $(BALL_INSTALL_PATH)/usr/bin/BALLView		 debian/ballview/usr/bin/

	find $(BALL_INSTALL_PATH)/usr/lib/ -name libBALL*.so.* | xargs -r cp --target-directory debian/libball$(SOVERSION)/usr/lib/
	find $(BALL_INSTALL_PATH)/usr/lib/ -name libVIEW*.so.* | xargs -r cp --target-directory debian/libballview$(SOVERSION)/usr/lib/

	# debian needs the logo in the ballview - package, not in the libball
	cp $(BALL_INSTALL_PATH)/usr/share/BALL/data/graphics/ballview*.xpm debian/ballview/usr/share/pixmaps/

	cp -r $(CURDIR)/source/EXAMPLES/PYTHON    debian/python-ball/usr/share/BALL-$(SOVERSION)
	cp $(BALL_INSTALL_PATH)/usr/lib/BALL.py       debian/python-ball/usr/$(PYTHON_SITE_PATH)
	cp $(BALL_INSTALL_PATH)/usr/lib/BALLCore.so   debian/python-ball/usr/$(PYTHON_SITE_PATH)
	cp $(BALL_INSTALL_PATH)/usr/lib/VIEW.so       debian/python-ballview/usr/$(PYTHON_SITE_PATH)

	chmod ugo-x debian/python-ball/usr/share/BALL-$(SOVERSION)/PYTHON/UTILITIES/*.py
	chmod ugo-x debian/python-ball/usr/share/BALL-$(SOVERSION)/PYTHON/BALLView/*.py
	chmod ugo-x debian/python-ball/usr/share/BALL-$(SOVERSION)/PYTHON/howtos/*.py

	# -dev packages are arch dependent
	mkdir -p debian/libball$(SOVERSION)-dev/usr/lib \
		debian/libballview$(SOVERSION)-dev/usr/include/BALL \
		debian/libballview$(SOVERSION)-dev/usr/lib \
		debian/libball$(SOVERSION)-dev/usr/include
	# move the cmake configuration files to their final location
	cp -R $(BALL_INSTALL_PATH)/usr/lib/cmake/ debian/libball$(SOVERSION)-dev/usr/lib

	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL       debian/libball$(SOVERSION)-dev/usr/include
	cp -r $(BALL_INSTALL_PATH)/usr/include/BALL/VIEW  debian/libballview$(SOVERSION)-dev/usr/include/BALL

	# get rid of the VIEW includes in libball-dev
	rm -rf debian/libball$(SOVERSION)-dev/usr/include/BALL/VIEW

	# eliminating chrpath settings
	chmod 755 debian/ballview/usr/bin/BALLView
	chrpath -d debian/ballview/usr/bin/BALLView
	find debian -name "*.so" | xargs -r chrpath -d 

	dh_pysupport -s
	dh_sip -s

install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	mkdir -p debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html \
		debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc

	cp    $(BALL_INSTALL_PATH)/usr/share/BALL/doc/TUTORIAL/tutorial.pdf   debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/classes                 debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/internal                debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	# we need the BALLView documentation in the data path as well... sorry for that
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/BALLView debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/doc
	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/doc/BALL     debian/libball$(SOVERSION)-doc/usr/share/doc/libball$(SOVERSION)/html

	cp -r $(BALL_INSTALL_PATH)/usr/share/BALL/data    debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION) 


	# This should already be fixed, by the debian permcheck
	#chmod ugo-x debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/QSAR/*
	#chmod ugo-x debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/CHARMM/charmm*
	#chmod ugo-x debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/graphics/*
	##chmod 755   debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/graphics/QuEasy/
	#chmod 755   debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/graphics/icons/
	#chmod ugo-x debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/structures/*
	#chmod 755   debian/libball$(SOVERSION)-data/usr/share/BALL-$(SOVERSION)/data/structures/DB/


	# links shoulds become relative
	# FIXME investigate how to achieve that properly 
	#ln -s ${LIBBALL_TARGET} libball$(SOVERSION)-dev/usr/lib/libBALL.so
	#ln -s ${LIBVIEW_TARGET} libballview$(SOVERSION)-dev/usr/lib/libVIEW.so

	dh_pysupport -i
	dh_sip -i


binary-common: 
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installmenu
#	dh_python
	dh_installman
	dh_link
	dh_strip --dbg-package=ballview-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

get-orig-source:
	if [ -x /usr/bin/uscan ]; then \
	  uscan --verbose --force-download ; \
	else \
	  echo "uscan is not installed to perform the download." ; \
	fi

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure build-arch build-indep

## ball 1.4.1%2B20111206

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
-export CFLAGS = -Wall -g -Wno-unused-variable -fpermissive
+export CFLAGS = -Wall -g -Wno-unused-variable -fpermissive -Wno-format-security 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0
 else
@@ -67,6 +67,7 @@
 	find . -name "*.o" | xargs -r rm
 	find . -type l | xargs -r rm
 	find doc/TUTORIAL/ -name "tutorial.*" | egrep -v ".(tex|bib)$$" |xargs -r rm 
+	find . -name "*.doc" -delete
 
 	dh_clean build-stamp configure-stamp build-arch-stamp build-indep-stamp
 
@@ -94,7 +95,7 @@
 	# debian needs the logo in the ballview - package, not in the libball
 	cp $(BALL_INSTALL_PATH)/usr/share/BALL/data/graphics/ballview*.xpm debian/ballview/usr/share/pixmaps/
 
-	cp -r $(CURDIR)/source/EXAMPLES/PYTHON    debian/python-ball/usr/share/BALL-$(SOVERSION)
+	cp -r source/EXAMPLES/PYTHON    debian/python-ball/usr/share/BALL-$(SOVERSION)
 	cp $(BALL_INSTALL_PATH)/usr/lib/BALL.py       debian/python-ball/usr/$(PYTHON_SITE_PATH)
 	cp $(BALL_INSTALL_PATH)/usr/lib/BALLCore.so   debian/python-ball/usr/$(PYTHON_SITE_PATH)
 	cp $(BALL_INSTALL_PATH)/usr/lib/VIEW.so       debian/python-ballview/usr/$(PYTHON_SITE_PATH)
